/*	explosion.c	*/

#include "explosion.h"
#include <stdlib.h>
#include <time.h>

Explosion * createExplosion(int x, int y, int block_colour) {
	// Reserve memory for explosion type
	Explosion * exp = (Explosion *) malloc(sizeof(Explosion));
	// Set explosion surface index
	exp->block_colour = block_colour;
	
	// Reserve memory for explosion peices.
	exp->peices = (Block_Peice *) malloc(sizeof(Block_Peice) * 4);
	
	// Initialize positions and explosion directions.
	int i;
	for (i = 0; i < 4; i++) {
		exp->peices[i].x = x;
		exp->peices[i].y = y;
		exp->peices[i].x_speed = -16 + (rand() % 32);
		exp->peices[i].y_speed = -16 + (rand() % 32);
		x += 16;
		if (i == 1) {
			x -= 32;
			y += 16;
		}
	}

	// Return pointer to new explosion	
	return exp;
}

void animateExplosion(Explosion * exp) {
	int i;
	for (i = 0; i < 4; i++) {
		exp->peices[i].x += exp->peices[i].x_speed;
		exp->peices[i].y += exp->peices[i].y_speed;
		if (exp->peices[i].y_speed < 16) exp->peices[i].y_speed += 1;
	}
}

int explosionDone(Explosion * exp) {
	// Set done flag to true
	int done = 1;
	
	// Unset if the flag if any peices are within the play area.
	int i;
	for (i = 0; i < 4; i++) {
		if (exp->peices[i].y < 464) {
			if (exp->peices[i].x > 0 && exp->peices[i].x < 640) {
				done = 0;
				break;
			}
		}
	}
	
	return done;
}

void freeExplosion(Explosion * exp) {
	// Make block surface index invalid
	exp->block_colour = -1;
	
	// Free memory allocated to peices.
	free(exp->peices);
	
	// Free memory reserved for explosion
	free(exp);
}
